/*
Collection of template array functions
Copyright (C) 2002  Daniel Yukio Yokomiso

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

See attached file lesser.txt for a copy of the GNU Lesser General Public License
 */

module deimos.utils;
template TUtils(T) {
    public void swap(inout T left, inout T right) {
        T temp = left;
        left = right;
        right = temp;
    }
}
unittest {
    alias TUtils!(char) util;
    char left = 'a'; 
    char right = 'c'; 
    util.swap(left, right);
    assert(left == 'c');
    assert(right == 'a');
    util.swap(left, right);
    assert(left == 'a');
    assert(right == 'c');
    char[] ab = "ab";
    util.swap(ab[0], ab[1]);
    assert(ab == "ba");
    util.swap(ab[0], ab[1]);
    assert(ab == "ab");
    char[] abc = "abc";
    util.swap(abc[0], abc[2]);
    assert(abc == "cba");
    util.swap(abc[0], abc[2]);
    assert(abc == "abc");
    printf("TUtils(char).swap tests passed!\r\n");
}
